
QGIS Application - Bug report #11186

Deleting records from a table is very slow when the table is open for viewing

2014-09-11 08:33 AM - Paolo Cavallini

Status: Closed

Priority: Normal

Assignee:

Category: Attribute table

Affected QGIS version:2.18.17 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 19498

Description

Tens of minutes for a PostGIS table with 200k records, with qgis taking 100% of CPU. The issue was apparently fixed some time ago by

Kuhn by introducing some kind of "batch job detection" on attribute table side.

History

#1 - 2014-09-12 01:50 AM - Matthias Kuhn

The problem most likely is introduced by the fact, that each feature is deleted with a separate call to QgsVectorLayer::deleteFeature( QgsFeatureId fid )

which in turn leads to one signal being emitted for each deleted feature and the attribute table updates accordingly with a expensive operation.

The same applies to adding features/changing attributes.

IIRC I resolved it for changing attributes by watching for editCommandStarted()/editCommandEnded() signals on attribute table side and buffering any edit

happening in between, but only updating the attribute table once in the end (batch job detection).

The same could be done for deleting features on attribute table side. Instead I would propose to implement this feature directly inside QgsVectorLayer and

emit batched signals for operation happening inside an edit command and per-operation signals when outside an edit command. This would have the

advantage of not having to reinvent the wheel for every part where expensive operations can be performed once per edit command.

#2 - 2017-05-01 01:08 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#3 - 2018-03-07 04:42 PM - Paolo Cavallini

- Status changed from Open to Feedback

- Description updated

Matthias, do you consider this fixed?

#4 - 2018-03-07 10:39 PM - Giovanni Manghi

- Affected QGIS version changed from 2.4.0 to 2.18.17

- Status changed from Feedback to Open

Such operation on large tables is still painfully slow on 2.18. Not sure about 3.
#5 - 2019-03-09 03:09 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release  (LTR) version. This is a major step in our history – a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR  as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the

relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.

#6 - 2019-03-09 05:12 PM - Paolo Cavallini

It seems to go well on 3.6.
